注册 登录  
 加关注
   显示下一条  |  关闭
温馨提示!由于新浪微博认证机制调整,您的新浪微博帐号绑定已过期,请重新绑定!立即重新绑定新浪微博》  |  关闭

信息 灵感 创新

I? =Information,Inspiration,Innovation

 
 
 

日志

 
 
关于我

we are 5. Mathematics, Computation, Programming, Engineering, and Making fun of life.

网易考拉推荐

由圆外一点做该圆的切线  

2010-12-16 12:58:21|  分类: ObjectARX |  标签: |举报 |字号 订阅

  下载LOFTER 我的照片书  |

    圆外一点做切线,几何原理如下:

由圆外一点做该圆的切线 - Castor - 趁年轻,多折腾~~

 

    蓝色的圆O和点A为已知,现求做切线,可以这么做:连接AO,取中点P,过PPA为半径做圆P,与圆O交于T1T2两点,则AT1AT2即为切线。因为PT2=PA=PO,所以三角形AOT1AOT2为直角三角形,故AT1AT2为切线。

实现代码如下:

[CommandMethod("test")]

public void test()

{

    Document doc = Application.DocumentManager.MdiActiveDocument;

    Database db = doc.Database;

    Editor ed = doc.Editor;

    Transaction trans = db.TransactionManager.StartTransaction();

    BlockTable bt = trans.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;

    BlockTableRecord btr = trans.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;

 

    Circle c = new Circle();

    Point3d a = new Point3d();

    //获取圆

    TypedValue[] tv = new TypedValue[1];

    tv.SetValue(new TypedValue(0, "CIRCLE"), 0);

    SelectionFilter sf = new SelectionFilter(tv);

    PromptSelectionResult psr = ed.GetSelection(sf);

    if (psr.Status == PromptStatus.OK)

    {

        SelectionSet ss = psr.Value;

        c = trans.GetObject(ss[0].ObjectId, OpenMode.ForRead) as Circle;

    }

    //获取点

    DBPoint dba = new DBPoint();

    tv = new TypedValue[1];

    tv.SetValue(new TypedValue(0, "POINT"), 0);

    sf = new SelectionFilter(tv);

    psr = ed.GetSelection(sf);

    if (psr.Status == PromptStatus.OK)

    {

        SelectionSet ss = psr.Value;

        dba = trans.GetObject(ss[0].ObjectId, OpenMode.ForRead) as DBPoint;

    }

    a = dba.Position;

    Point3d p = new Point3d((a.X + c.Center.X) / 2, (a.Y + c.Center.Y) / 2, 0);

    Vector3d v = p.GetVectorTo(a);

    double r = v.Length;

    if (r <= c.Radius)

    {

        ed.WriteMessage("\n点在所选圆内,无法做切线!");

        trans.Dispose();//一定要终止交易

        return;

    }

    Circle cp = new Circle();

    cp.SetDatabaseDefaults();

    cp.Radius = r;

    cp.Center = p;

    //切点

    Point3dCollection t = new Point3dCollection();

    cp.IntersectWith(c, Intersect.OnBothOperands, t, 0, 0);

    //画切线

    foreach (Point3d tt in t)

    {

        Line l = new Line(tt, a);

        btr.AppendEntity(l);

        trans.AddNewlyCreatedDBObject(l, true);

    }

    trans.Commit();

    trans.Dispose();

}

 运行效果如下:

由圆外一点做该圆的切线 - Castor - 趁年轻,多折腾~~

 

  评论这张
 
阅读(1992)| 评论(0)
推荐 转载

历史上的今天

评论

<#--最新日志,群博日志--> <#--推荐日志--> <#--引用记录--> <#--博主推荐--> <#--随机阅读--> <#--首页推荐--> <#--历史上的今天--> <#--被推荐日志--> <#--上一篇,下一篇--> <#-- 热度 --> <#-- 网易新闻广告 --> <#--右边模块结构--> <#--评论模块结构--> <#--引用模块结构--> <#--博主发起的投票-->
 
 
 
 
 
 
 
 
 
 
 
 
 
 

页脚

网易公司版权所有 ©1997-2016